/*-
 * Copyright (c) 2002-2003 Norikatsu Shigemura
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: pluginwrapper.h,v 1.4 2005/01/09 20:48:11 nork Exp $
 */

/*
 *
 */
#define	ENV_DSPDEV			"PLUGINWRAPPER_DSP_DEVICE"
#define	DSP_DEVICE			"/dev/dsp"


/*
 *
 */
#if	defined(__FreeBSD__) || defined(__DragonFly__)
#define	DEV_SND_MAJOR			30
#else
#error	Please set DEV_SND_MAJOR.
#endif


/*
 *
 */
#ifdef	DEBUG
#	include <stdio.h>
#	include <unistd.h>
#	define	dprintf(str, ...)	fprintf(stderr, "[%d] " str "\n", getpid() ,##__VA_ARGS__)
#	define	CLEAR_ERRNO		errno = 0
#else
#	define	dprintf(str, ...)	/* NOTHING TO DO */
#	define	CLEAR_ERRNO		/* NOTHING TO DO */
#endif


/*
 *
 */
#define	extern_alias(type, var, orgvar) \
	extern  type  var  __attribute__ ( (alias(#orgvar)) );  \
	__asm__(".comm  " #var ", 4, 4")
