/*-
 * Copyright (c) 2002-2003 Norikatsu Shigemura
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: libgcc.c,v 1.2 2003/11/09 09:00:00 nork Exp $
 */

#include <sys/types.h>
#include <stdlib.h>


#if __GNUC__ > 2


/* 
 * __builtin_vec_new, __builtin_vec_delete are in gcc 2.95.4's libgcc.a.
 * But there are not in new gcc (3.0 or later?).
 */
void *
__builtin_vec_new(size_t sz /* XXX: ,std::nothrow_t& nothrow */)
{
	void *p;

	if(  sz == 0  )
		sz = 1;

	p = malloc(sz);

	/* XXX: ERROR HANDLER is not available */

	return p; 
}


void
__builtin_vec_delete(void *ptr)
{
	if(  ptr  )
		free(ptr);
}


extern ssize_t _write(int, const void *, size_t);
void
__pure_virtual(void)
{
#define	MESSAGE "pure virtual method called\n"
	_write(2, MESSAGE, sizeof (MESSAGE) - 1);
#undef	MESSAGE
}


#endif
